d3.csv('https://gist.githubusercontent.com/kollirohit2000/79ff14d3db9f498b15763809f5969a98/raw/ab5d76a475e6b7ab7341751b26e1c5ecf9d164b4/penguins.csv', function(err, rows){
function unpack(rows, key) {
	return rows.map(function(row)
	{ return row[key]; });}
  var colors = []
  var i = 0
    for (i=0; i < unpack(rows, 'Species').length; i++) {
      if (unpack(rows, 'Species')[i] == "Adelie Penguin (Pygoscelis adeliae)") {
        colors.push(0)
      } else if (unpack(rows, 'Species')[i] == "Chinstrap penguin (Pygoscelis antarctica)") {
        colors.push(0.5)
      } else if (unpack(rows, 'Species')[i] == "Gentoo penguin (Pygoscelis papua)") {
        colors.push(1)
      }
    }

    var pl_colorscale=[
               [0.0, '#00FF00'],
               [0.333, '#0000FF'],
               [0.333, '#FFFF00'],
               [0.666, '#FF00FF'],
               [0.666, '#00FFFF'],
               [1, '#C0C0C0']
    ]
var trace1 = {
	x:unpack(rows, 'BodyMass'), 
  y: unpack(rows, 'CulmenLength'), 
  z: unpack(rows, 'FlipperLength'),
	mode: 'markers',
      marker: {
        color: colors,
        colorscale:pl_colorscale,
        size: 12,
        line: {
          color: 'white',
          width: 0.5
        }
      },
	type: 'scatter3d'
};


var data = [trace1];
var layout = {margin: {
	l: 0,
	r: 0,
	b: 0,
	t: 0
  },
	scene: {
		xaxis:{title: 'BodyMass',backgroundcolor: "rgb(200, 230, 230)",
	 gridcolor: "rgb(255, 255, 255)",
	 showbackground: true,
	 zerolinecolor: "rgb(255, 255, 255)"},
		yaxis:{title: 'CulmenLength',
     backgroundcolor: "rgb(200, 200,230)",
     gridcolor: "rgb(255, 255, 255)",
     showbackground: true,
     zerolinecolor: "rgb(255, 255, 255)"},
		zaxis:{title: 'FlipperLength',
     backgroundcolor: "rgb(230, 230,230)",
     gridcolor: "rgb(255, 255, 255)",
     showbackground: true,
     zerolinecolor: "rgb(255, 255, 255)"},
		}        
  };
Plotly.newPlot('myDiv', data, layout);
});
